'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var slatePluginsCommon = require('@udecode/slate-plugins-common');
var slatePluginsCore = require('@udecode/slate-plugins-core');

const MARK_HIGHLIGHT = 'highlight';
const DEFAULTS_HIGHLIGHT = {
  hotkey: 'mod+shift+h'
};

const useDeserializeHighlight = () => editor => {
  const options = slatePluginsCore.getSlatePluginOptions(editor, MARK_HIGHLIGHT);
  return {
    leaf: slatePluginsCommon.getLeafDeserializer(Object.assign({
      type: options.type,
      rules: [{
        nodeNames: ['MARK']
      }]
    }, options.deserialize))
  };
};

/**
 * Enables support for highlights, useful when reviewing
 * content or highlighting it for future reference.
 */

const useHighlightPlugin = () => ({
  pluginKeys: MARK_HIGHLIGHT,
  renderLeaf: slatePluginsCommon.useRenderLeaf(MARK_HIGHLIGHT),
  deserialize: useDeserializeHighlight(),
  onKeyDown: slatePluginsCommon.useOnKeyDownMark(MARK_HIGHLIGHT)
});

exports.DEFAULTS_HIGHLIGHT = DEFAULTS_HIGHLIGHT;
exports.MARK_HIGHLIGHT = MARK_HIGHLIGHT;
exports.useDeserializeHighlight = useDeserializeHighlight;
exports.useHighlightPlugin = useHighlightPlugin;
//# sourceMappingURL=index.js.map
